﻿using System;
using System.Threading.Tasks;
using CommonBehaviors.Actions;
using Styx;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using System.Diagnostics;
using Styx.Common;
using System.Windows.Media;
using Hades.spellManager;
using Hades.spellsAndAuras;
using Hades.units;
using System.Linq;
using Styx.CommonBot.Frames;

namespace Hades
{
    class Hades : CombatRoutine
    {
        private static uint CurrentFury => StyxWoW.Me.GetPowerInfo(WoWPowerType.Fury).Current;
        
        private static LocalPlayer Me
        {
            get
            {
                return StyxWoW.Me;
            }
        }
        public override WoWClass Class
        {
            get
            {
                if (Me.Specialization == WoWSpec.DemonHunterHavoc || Me.Specialization == WoWSpec.DemonHunterVengeance)
                    return WoWClass.DemonHunter;
                else
                    return WoWClass.None;
            }
        }
        public override string Name
        {
            get
            {
                return "Hades Demon Hunter Combat Routine - By Exocet";
            }
        }
        public override void Initialize()
        {

            Logging.Write(Colors.Tomato, "Hello {0}!", Me.SafeName);
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.Tomato, "For Best performance please use: Enyo");
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.Tomato, "-- Hades --");
            Logging.Write(Colors.Tomato, "-- Version: v0.1 --");
            Logging.Write(Colors.Tomato, "-- by Exocet --");
            Logging.Write(Colors.Tomato, "-- Demon Hunter CombatRoutine --");
            TalentManager.initTalents();

        }
        public override void ShutDown()
        {

        }
        public override Composite CombatBehavior
        {
            get
            {
                if (Me.Specialization == WoWSpec.DemonHunterHavoc)
                    return new ActionRunCoroutine(ctx => HavocCoroutine());
                else
                    return new ActionRunCoroutine(ctx => VengenceCoroutine());
            }
        }
        private static Stopwatch _enemyScanner = new Stopwatch();


        //private static int enemyCount;
        private static int meleeUnitsInCombatWithMe;
        private static int rangedUnitsInCombatWithMe;
        private static int allUnitsInRangeInCombatWithMe;
        private static async Task<bool> HavocCoroutine()
        {

            if (_enemyScanner.ElapsedMilliseconds >= 500)
            {
                //enemyCount = Units.SurroundingEnemiesInRange().Count;
                meleeUnitsInCombatWithMe = Units.SurroundingEnemiesInRange().Where(u => u.IsWithinMeleeRange).Count();
                rangedUnitsInCombatWithMe = Units.SurroundingEnemiesInRange(30).Count();
                allUnitsInRangeInCombatWithMe = meleeUnitsInCombatWithMe + rangedUnitsInCombatWithMe;
                _enemyScanner.Restart();

            }
            else if (_enemyScanner.IsRunning == false)
            {
                _enemyScanner.Start();
                Logging.WriteQuiet(String.Format("Scanning Enemies"));
            }

            

            // make sure we are actually in combat and we have something in range.
            if (allUnitsInRangeInCombatWithMe >= 1)
            {
                //Logging.Write(string.Format($"combat:{Me.IsActuallyInCombat},mu:{meleeUnitsInCombatWithMe},ru:{rangedUnitsInCombatWithMe},au:{allUnitsInRangeInCombatWithMe}"));

                #region Save Me From Dying!
                // use defensive cooldowns
                #region Use Bandages
                if (Me.HealthPercent < 70)
                {
                    // use a bandage.  Let's see if we have any.
                    WoWItem bandage = FindBestBandage();
                    if (bandage != null)
                    {
                        UseItem(bandage);
                    }
                }
                #endregion

                #region Use Blur!  Ahh we dyin'
                if (Me.HealthPercent < 65 && SpellManager.CanCast(SpellsAndAuras.Blur))
                {
                    if (await AsyncSpellManager.SpellCast(SpellsAndAuras.Blur))
                    {
                        return true;
                    }
                }
                #endregion

                #region Use Darkness!  ahh we really dyin'
                if (Me.HealthPercent < 50 && SpellManager.CanCast(SpellsAndAuras.Darkness))
                {
                    if (await AsyncSpellManager.SpellCast(SpellsAndAuras.Darkness))
                    {
                        return true;
                    }
                }

                #endregion

                #region try to stun whatever is killin' me
                if (Me.HealthPercent < 40
                    && SpellManager.CanCast(SpellsAndAuras.ChaosNova)
                    && meleeUnitsInCombatWithMe >= 1)
                {
                    if (await AsyncSpellManager.SpellCast(SpellsAndAuras.ChaosNova))
                    {
                        return true;
                    }
                }

                #endregion

                #endregion

                #region Get Buffed (Offensive)
                if (Me.CurrentTarget != null
                    && SpellManager.CanCast(SpellsAndAuras.MetamorphosisSpell))
                {
                    if (await AsyncSpellManager.CastGroundSpell(SpellsAndAuras.MetamorphosisSpell, Me.CurrentTarget))
                    {
                        return true;
                    }
                }
                #endregion

                #region Multi-Target DPS
                // these abilities need 3 or more to be efficient
                if (meleeUnitsInCombatWithMe >= 3) // eventually change 3 to a variable
                {
                    #region Multi-Target Vengeful Retreat
                    // use it if we have Prepared talent differently
                    if (Me.CurrentTarget.IsWithinMeleeRange                                                 // is in melee range
                            && SpellManager.CanCast(SpellsAndAuras.VengefulRetreat)                         // only cast this if we have vengeful retreat up
                            && SpellManager.CanCast(SpellsAndAuras.FelRush)                                 // we can cast fel rush
                            && Me.FuryPercent <= 85                                                         // and fury < 70
                            && TalentManager.HavocPrepared                                                  // We took prepared so use 85 or less
                            && (AsyncSpellManager.GetSpellCD(SpellsAndAuras.FelRush).TotalMilliseconds < 500)) // and cooldown timer < 500ms (2nd one)

                    {
                        if (await AsyncSpellManager.SpellCast(SpellsAndAuras.VengefulRetreat))
                        {
                            return true;
                        }
                    }

                    // use it if we DO NOT have Prepared talent
                    if (Me.CurrentTarget.IsWithinMeleeRange                                                 // is in melee range
                            && SpellManager.CanCast(SpellsAndAuras.VengefulRetreat)                         // only cast this if we have vengeful retreat up
                            && SpellManager.CanCast(SpellsAndAuras.FelRush)                                 // we can cast fel rush
                            && !TalentManager.HavocPrepared                                                  // We took prepared so use 85 or less
                            && (AsyncSpellManager.GetSpellCD(SpellsAndAuras.FelRush).TotalMilliseconds < 500)) // and cooldown timer < 500ms (2nd one)

                    {
                        if (await AsyncSpellManager.SpellCast(SpellsAndAuras.VengefulRetreat))
                        {
                            return true;
                        }
                    }
                    #endregion

                    #region Multi-Target Fel Rush
                    // use this in combination with vengeful retreat
                    if (!Me.CurrentTarget.IsWithinMeleeRange                                        // in melee range
                        && SpellManager.CanCast(SpellsAndAuras.FelRush)                             // we can cast Fel Rush
                        && TalentManager.HavocFelMastery                                            // we took the talent for fel mastery
                        && Me.CurrentRage <= 70                                                     // make sure we have 70 or less rage
                        && Me.CurrentTarget.Distance >= 10                                          // make sure we aren't too close
                        && Me.CurrentTarget.Distance <= 30)                                         // make sure we aren't too far                                          
                    {
                        if (await AsyncSpellManager.SpellCast(SpellsAndAuras.FelRush))
                        {
                            return true;
                        }
                    }

                    // use to engage
                    if (!Me.CurrentTarget.IsWithinMeleeRange                                        // in melee range
                        && SpellManager.CanCast(SpellsAndAuras.FelRush)                             // we can cast Fel Rush
                        && !TalentManager.HavocFelMastery                                           // no fel mastery talent; use like normal.
                        && Me.CurrentTarget.Distance >= 10                                          // make sure we aren't too close
                        && Me.CurrentTarget.Distance <= 30)                                         // make sure we aren't too far                                          
                    {
                        if (await AsyncSpellManager.SpellCast(SpellsAndAuras.FelRush))
                        {
                            return true;
                        }
                    }
                    #endregion

                    #region Multi-Target Eye Beam
                    if (SpellManager.CanCast(SpellsAndAuras.EyeBeam))
                    {
                        if (await AsyncSpellManager.SpellCast(SpellsAndAuras.EyeBeam, false))
                        {
                            return true;
                        }
                    }
                    #endregion
                }

                if (meleeUnitsInCombatWithMe >= 2)
                {
                    #region Multi-Target Chaos Strike w/ talent

                    if (Me.CurrentTarget.IsWithinMeleeRange                     // unit is in melee range
                        && SpellManager.CanCast(SpellsAndAuras.ChaosStrike)     // we can cast chaos strike
                        && TalentManager.HavocChaosCleave                       // we took chaos cleave
                    )
                    {
                        if (await AsyncSpellManager.SpellCast(SpellsAndAuras.ChaosStrike))
                        {
                            return true;
                        }
                    }
                    #endregion
                }

                if (meleeUnitsInCombatWithMe >= 4)
                {
                    #region Multi-Target Blade Dance
                    if (Me.CurrentTarget.IsWithinMeleeRange
                        && SpellManager.HasSpell(SpellsAndAuras.BladeDance))
                    {
                        if (await AsyncSpellManager.SpellCast(SpellsAndAuras.BladeDance))
                        {
                            return true;
                        }
                    }
                    #endregion
                }

                if (meleeUnitsInCombatWithMe >= 3)
                {
                    #region Multi-Target Chaos Strike (Rage Dump)

                    if (Me.CurrentTarget.IsWithinMeleeRange                     // unit is in melee range
                      && SpellManager.CanCast(SpellsAndAuras.ChaosStrike)       // we can cast chaos strike
                      && Me.RagePercent >= 70                                   // more than 70 rage, rage dump
                    )
                    {
                        if (await AsyncSpellManager.SpellCast(SpellsAndAuras.ChaosStrike))
                        {
                            return true;
                        }
                    }
                    #endregion

                    #region Multi-Target Demon's Bit (Rage Generator)

                    if (Me.CurrentTarget.IsWithinMeleeRange
                        && SpellManager.CanCast(SpellsAndAuras.DemonsBite)
                        && !TalentManager.HavocDemonBlades)
                    {
                        if (await AsyncSpellManager.SpellCast(SpellsAndAuras.DemonsBite))
                        {
                            return true;
                        }
                    }
                    #endregion

                    #region Multi-Target Glaive Thrower (Out of Range)
                    if (!Me.CurrentTarget.IsWithinMeleeRange                        // not in range
                        && SpellManager.CanCast(SpellsAndAuras.ThrowGlaive))        // can cast glaive
                    {
                        if (await AsyncSpellManager.SpellCast(SpellsAndAuras.ThrowGlaive, false))
                        {
                            return true;
                        }
                    }

                    #endregion
                }
                #endregion

                #region Single-Target DPS
                #region Single-Target Vengeful Retreat
                // use it if we have Prepared talent differently
                if (Me.CurrentTarget.IsWithinMeleeRange                                                 // is in melee range
                        && SpellManager.CanCast(SpellsAndAuras.VengefulRetreat)                         // only cast this if we have vengeful retreat up
                        && SpellManager.CanCast(SpellsAndAuras.FelRush)                                 // we can cast fel rush
                        && Me.FuryPercent <= 85                                                         // and fury < 70
                        && TalentManager.HavocPrepared                                                  // We took prepared so use 85 or less
                        && (AsyncSpellManager.GetSpellCD(SpellsAndAuras.FelRush).TotalMilliseconds < 500)) // and cooldown timer < 500ms (2nd one)

                {
                    if (await AsyncSpellManager.SpellCast(SpellsAndAuras.VengefulRetreat))
                    {
                        return true;
                    }
                }

                // use it if we DO NOT have Prepared talent
                if (Me.CurrentTarget.IsWithinMeleeRange                                                 // is in melee range
                        && SpellManager.CanCast(SpellsAndAuras.VengefulRetreat)                         // only cast this if we have vengeful retreat up
                        && SpellManager.CanCast(SpellsAndAuras.FelRush)                                 // we can cast fel rush
                        && !TalentManager.HavocPrepared                                                  // We took prepared so use 85 or less
                        && (AsyncSpellManager.GetSpellCD(SpellsAndAuras.FelRush).TotalMilliseconds < 500)) // and cooldown timer < 500ms (2nd one)

                {
                    if (await AsyncSpellManager.SpellCast(SpellsAndAuras.VengefulRetreat))
                    {
                        return true;
                    }
                }
                #endregion

                #region Single-Target Fel Rush
                // use this in combination with vengeful retreat
                if (!Me.CurrentTarget.IsWithinMeleeRange                                        // in melee range
                    && SpellManager.CanCast(SpellsAndAuras.FelRush)                             // we can cast Fel Rush
                    && TalentManager.HavocFelMastery                                            // we took the talent for fel mastery
                    && Me.CurrentRage <= 70                                                     // make sure we have 70 or less rage
                    && Me.CurrentTarget.Distance >= 10                                          // make sure we aren't too close
                    && Me.CurrentTarget.Distance <= 30)                                         // make sure we aren't too far                                          
                {
                    if (await AsyncSpellManager.SpellCast(SpellsAndAuras.FelRush))
                    {
                        return true;
                    }
                }

                // use to engage
                if (!Me.CurrentTarget.IsWithinMeleeRange                                        // in melee range
                    && SpellManager.CanCast(SpellsAndAuras.FelRush)                             // we can cast Fel Rush
                    && !TalentManager.HavocFelMastery                                           // no fel mastery talent; use like normal.
                    && Me.CurrentTarget.Distance >= 10                                          // make sure we aren't too close
                    && Me.CurrentTarget.Distance <= 30)                                         // make sure we aren't too far                                          
                {
                    if (await AsyncSpellManager.SpellCast(SpellsAndAuras.FelRush))
                    {
                        return true;
                    }
                }
                #endregion

                #region Single-Target Chaos Strike (Rage Dump)
                if (meleeUnitsInCombatWithMe >= 1
                    && CurrentFury >= 70                                    // we have 70 or more fury (rage dump)
                    && Me.CurrentTarget.IsWithinMeleeRange                  // we are in melee range
                    && SpellManager.CanCast(SpellsAndAuras.ChaosStrike))    // we can cast chaos strike
                {
                    if (await AsyncSpellManager.SpellCast(SpellsAndAuras.ChaosStrike))
                    {
                        return true;
                    }
                }
                #endregion

                #region Single-Target Demon's Bite (Rage Generator)
                if (meleeUnitsInCombatWithMe >= 1
                    && Me.CurrentTarget.IsWithinMeleeRange
                    && SpellManager.CanCast(SpellsAndAuras.DemonsBite)
                    && !TalentManager.HavocDemonBlades)
                {
                    if (await AsyncSpellManager.SpellCast(SpellsAndAuras.DemonsBite))
                    {
                        return true;
                    }
                }
                #endregion

                #region Single-Target Glaive Thrower (Melee Range w/ Demon Blades)
                if (allUnitsInRangeInCombatWithMe >= 1                      // we are fighting someone!
                    && Me.CurrentTarget.Distance < 30                       // we are within the 30 yard range
                    && TalentManager.HavocDemonBlades                       // we have demon blades (no demons bite, so throw a glaive if no rage)
                    && Me.CurrentRage < 70                                  // not enough rage to care about another ability, let's throw it in
                    && SpellManager.CanCast(SpellsAndAuras.ThrowGlaive))    // glaive is up
                {
                    if (await AsyncSpellManager.SpellCast(SpellsAndAuras.ThrowGlaive, false))
                    {
                        return true;
                    }
                }
                #endregion

                #region Single-Target Glaive Thrower (Any Range w/ Low Rage)
                if (allUnitsInRangeInCombatWithMe >= 1                     // we are fighting someone!
                    && !Me.CurrentTarget.IsWithinMeleeRange                 // we are not in melee range, throw something at him!
                    && TalentManager.HavocDemonBlades                       // we have demon blades (no demons bite, so throw a glaive if no rage)
                    && Me.CurrentRage < 70                                  // not enough rage to care about another ability, let's throw it in
                    && SpellManager.CanCast(SpellsAndAuras.ThrowGlaive))    // glaive is up
                {
                    if (await AsyncSpellManager.SpellCast(SpellsAndAuras.ThrowGlaive, false))
                    {
                        return true;
                    }
                }
                #endregion
                #endregion
            }
            //Logging.Write(string.Format($"combat:{Me.IsActuallyInCombat},mu:{meleeUnitsInCombatWithMe},ru:{rangedUnitsInCombatWithMe},au:{allUnitsInRangeInCombatWithMe}"));
            return true;
        }

     
        public static WoWItem FindBestBandage()
        {
            return Me.CarriedItems
                .Where(b => b.ItemInfo.ItemClass == WoWItemClass.Consumable
                    && b.ItemInfo.ConsumableClass == WoWItemConsumableClass.Bandage
                    && (b.ItemInfo.RequiredSkillId == 0 || Me.GetSkill(b.ItemInfo.RequiredSkillId).CurrentValue >= b.ItemInfo.RequiredSkillLevel)
                    && b.ItemInfo.RequiredLevel <= Me.Level
                    && CanUseItem(b))
                .OrderBy(b => b.ItemInfo.Level)
                .ThenByDescending(b => b.ItemInfo.RequiredSkillLevel)
                .FirstOrDefault();
        }

        private static bool CanUseItem(WoWItem item)
        {
            return item.Usable && item.Cooldown <= 0 && !MerchantFrame.Instance.IsVisible;
        }

        private static void UseItem(WoWItem item, string log = null)
        {
            if (!CanUseItem(item))
                return;

            if (log == null)
                log = string.Format("/use {0}", item.Name);

            Logging.Write(log);
            item.Use();
        }
        private static async Task<bool> VengenceCoroutine()
        {

            if (_enemyScanner.ElapsedMilliseconds >= 500)
            {
                meleeUnitsInCombatWithMe = Units.SurroundingEnemiesInRange().Count;
                rangedUnitsInCombatWithMe = Units.SurroundingEnemiesInRange(30).Count;
                allUnitsInRangeInCombatWithMe = meleeUnitsInCombatWithMe + rangedUnitsInCombatWithMe;
                _enemyScanner.Restart();

            }
            else if (_enemyScanner.IsRunning == false)
            {
                _enemyScanner.Start();
                Logging.WriteQuiet(String.Format("Scanning Enemies"));
            }

            if (CurrentFury < 40 && Me.CurrentTarget.IsWithinMeleeRange && SpellManager.CanCast(SpellsAndAuras.DemonsBite))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.DemonsBite))
                {
                    return true;
                }
            }

            if (CurrentFury >= 40 && Me.CurrentTarget.IsWithinMeleeRange && SpellManager.CanCast(SpellsAndAuras.ChaosStrike))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.ChaosStrike))
                {
                    return true;
                }
            }

            if (meleeUnitsInCombatWithMe >= 3 && Me.CurrentTarget.IsWithinMeleeRange && SpellManager.HasSpell(SpellsAndAuras.BladeDance))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.BladeDance))
                {
                    return true;
                }
            }

            if (CurrentFury >= 50 && meleeUnitsInCombatWithMe >= 2 && SpellManager.CanCast(SpellsAndAuras.EyeBeam))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.EyeBeam, false))
                {
                    return true;
                }

            }

            if (meleeUnitsInCombatWithMe >= 1 && Me.CurrentTarget.IsWithinMeleeRange && SpellManager.CanCast(SpellsAndAuras.EyeBeam))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.ThrowGlaive, false))
                {
                    return true;
                }
            }

            return true;
        }
    }
}